with Interfaces.C.Strings; use Interfaces.C.Strings;
with Messages; use Messages;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
package Sessions is
  type Session is tagged private;
  pragma CPP_Class(Session);
  
  procedure Message_Transfer (Ses : Session; Destination : Unbounded_String; Msg : Message);   

  procedure Bind (Ses: Session; Queue_Name : Unbounded_String; Exchange_Name : Unbounded_String; Binding_Key : Unbounded_String); 

  procedure Exchange_Declare(Ses: Session; Exchange_Name : Unbounded_String; Exchange_Type : Unbounded_String; Alternate_Exchange : 				     Unbounded_String; Durable : Boolean; Auto_Delete : Boolean);
 
  procedure Exchange_Delete(Ses : Session; Exchange_Name : Unbounded_String; If_Unused : Boolean);  

  procedure Unbind(Ses : Session; Queue_Name : Unbounded_String; Exchange_Name : Unbounded_String; Binding_Key : Unbounded_String); 

  procedure Queue_Declare(Ses : Session; Queue_Name : Unbounded_String; Alternate_Exchange : Unbounded_String; Durable : Boolean;
			Exclusive : Boolean; Auto_Delete : Boolean);  

  procedure Queue_Delete(Ses : Session; Queue_Name : Unbounded_String; If_Unused : Boolean);  

  procedure Purge(Ses : Session; Queue_Name : Unbounded_String);  
  
  function New_Session return Session'class;
  pragma CPP_Constructor (New_Session);
  pragma Import(CPP, New_Session, "_ZN8SessionCC1Ev");

  private
    type Session is tagged record
      null;
    end record;

end Sessions;

